#ifndef ENGLISH
#include "global.h"
#include "confirm_window.h"
#include "../client_sources/particles.h"
#include "../client_sources/platform.h"


int view_confirm_window = 0;
int confirm_window_x = 200;
int confirm_window_y = 200;
int confirm_window_x_len = 300;
int confirm_window_y_len = 100;
int confirm_window_win = 0;

//buttons
int yes_x1 = 110;
int yes_x2 = 200;
int yes_y1 = 60;
int yes_y2 = 90;

int no_x1 = 210;
int no_x2 = 290;
int no_y1 = 60;
int no_y2 = 90;

int annule_x1 = 10;
int annule_x2 = 100;
int annule_y1 = 60;
int annule_y2 = 90;

void display_confirm_window ()
{

   if (confirm_window_win <= 0)
   {

      confirm_window_win =
         create_window ("Confirmation", 0, 0, confirm_window_x, confirm_window_y,
                        confirm_window_x_len, confirm_window_y_len,
                        ELW_WIN_DEFAULT);

      set_window_handler (confirm_window_win, ELW_HANDLER_DISPLAY,
                          &display_confirm_window_handler);

      set_window_handler (confirm_window_win, ELW_HANDLER_CLICK,
                          &check_confirm_window_interface);

   }
   else
   {
      show_window (confirm_window_win);

      select_window (confirm_window_win);
   }
   display_window (confirm_window_win);

}

int display_confirm_window_handler (window_info * win)
{
   glEnable (GL_BLEND);

   glBlendFunc (GL_ONE, GL_SRC_ALPHA);

   glDisable (GL_TEXTURE_2D);

   glDisable (GL_BLEND);

   glColor3f (0.77f, 0.57f, 0.39f);

   //buttons
   glBegin (GL_LINE_LOOP);
   glVertex3i(annule_x1, annule_y1, 0);
   glVertex3i(annule_x2, annule_y1, 0);
   glVertex3i(annule_x2, annule_y2, 0);
   glVertex3i(annule_x1, annule_y2, 0);
   glEnd ();
   
   glBegin (GL_LINE_LOOP);
   glVertex3i(yes_x1, yes_y1, 0);
   glVertex3i(yes_x2, yes_y1, 0);
   glVertex3i(yes_x2, yes_y2, 0);
   glVertex3i(yes_x1, yes_y2, 0);
   glEnd();
   
   glBegin (GL_LINE_LOOP);
   glVertex3i(no_x1, no_y1, 0);
   glVertex3i(no_x2, no_y1, 0);
   glVertex3i(no_x2, no_y2, 0);
   glVertex3i(no_x1, no_y2, 0);
   glEnd();
   //end buttons
   
   glEnable (GL_TEXTURE_2D);

   // The X
   draw_string (0 + win->len_x - 16, 0 + 2, (const unsigned char *) "X", 1);
   
   glColor3f (0.9f, 0.9f, 0.9f);
   draw_string_small(20, 20, (const unsigned char *)"Enregistrer avant de quitter?", 1);
   draw_string(annule_x1 + 5, annule_y1 + 5, (const unsigned char *)"annuler", 1);
   draw_string(yes_x1 + 25, yes_y1 + 5, (const unsigned char *)"oui", 1);
   draw_string(no_x1 + 20, no_y1 + 5, (const unsigned char *)"non", 1);
   
   return 1;
}

int check_confirm_window_interface (window_info * win, int _x, int _y)
{
   if (_x > yes_x1 && _x <= yes_x2 && _y > yes_y1 && _y <= yes_y2)
   {
      hide_window(confirm_window_win);
      save_map_file();
   }
   if (_x > no_x1 && _x <= no_x2 && _y > no_y1 && _y <= no_y2)
   {
   	/* Destroy our GL context, etc. */
	   destroy_map_tiles();
	   SDL_SetTimer(0,NULL);
       end_particles ();
	   SDL_Quit( );
       exit(0);
   }
   if (_x > annule_x1 && _x <= annule_x2 && _y > annule_y1 && _y <= annule_y2)
   {
       hide_window(confirm_window_win);
   }
   return 1;
}
#endif //ENGLISH

