#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#define true 1
#define false 0
#ifdef WINDOWS
#include <windows.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>

#ifdef ENGLISH
#include "../elc/platform.h"
#else //ENGLISH
#include "../client_sources/platform.h"
#endif //ENGLISH

#ifndef min
	#define min(x, y) (x<y?x:y)
#endif //min
#ifndef max
	#define max(x, y) (x>y?x:y)
#endif //max

#include <SDL.h>
#include <SDL_endian.h>

#if defined(LINUX) || defined(BSD)
#include <gtk/gtk.h>
#include "gui.h"
#include "gui_callbacks.h"
#include "gui_support.h"
#endif

#ifdef	ZLIB
#include	<zlib.h>
#endif

#ifdef ENGLISH
#include "../elc/cache.h"
#include "../elc/translate.h"
#include "../elc/elconfig.h"
#include "../elc/colors.h"
#include "../elc/errors.h"
#else //ENGLISH
#include "../client_sources/cache.h"
#include "../client_sources/translate.h"
#include "../client_sources/elconfig.h"
#include "../client_sources/colors.h"
#include "../client_sources/errors.h"
#endif //ENGLISH
#include "init.h"
#include "e3d.h"
#include "2d_objects.h"
#include "3d_objects.h"
#include "tiles.h"
#include "lights.h"
#include "interface.h"
#include "editor.h"
#include "map_io.h"
#include "shadows.h"
#include "reflection.h"
#include "draw_scene.h"
#include "browser.h"
#include "events.h"
#include "frustum.h"
#ifdef ENGLISH
#include "../elc/client_serv.h"
#include "../elc/textures.h"
#else //ENGLISH
#include "../client_sources/client_serv.h"
#include "../client_sources/textures.h"
#endif //ENGLISH
#include "font.h"
#include "elwindows.h"
#include "o3dow.h"
#include "replace_window.h"
#include "edit_window.h"
#ifndef ENGLISH
#include "help_window.h"
#include "confirm_window.h"
#include "mult_obj.h"
#include "help_xml.h"
#endif // ENGLISH
#ifdef ENGLISH
#include "../elc/particles.h"
#else //ENGLISH
#include "../client_sources/particles.h"
#endif //ENGLISH
#include "particles_window.h"
#include "gl_init.h"
#define sector_size_x 15
#define sector_size_y 15

#ifndef ENGLISH
int quit_request;
extern xmlDoc *help_doc;
#endif

extern int map_meters_size_x;
extern int map_meters_size_y;

extern int elwin_mouse;
extern int window_width;
extern int window_height;
extern int bpp;


extern Uint32 cur_time, last_time;

extern float camera_x_end_point;
extern float camera_z_end_point;
extern int last_texture;

extern float gcr,gcg,gcb;

//debug
extern int texture2;
extern int texture3;
//end of debug

extern  Uint8 *e3d_file_mem;
extern  Uint8 *handle_e3d_file_mem;

extern int have_multitexture;
extern int have_arb_compression;
extern int have_s3_compression;
extern int poor_man;
extern int ground_detail_text;

extern float clouds_movement_u;
extern float clouds_movement_v;
extern Uint32 last_clear_clouds;
extern float texture_scale;
extern int clouds_shadows;

extern int icons_text;

extern int video_mode;
extern int auto_save_time;
extern int limit_fps;

#if !defined(LINUX) && !defined(BSD) //extensions
extern PFNGLMULTITEXCOORD2FARBPROC		glMultiTexCoord2fARB;
extern PFNGLMULTITEXCOORD2FVARBPROC	glMultiTexCoord2fvARB;
extern PFNGLACTIVETEXTUREARBPROC		glActiveTextureARB;
extern PFNGLCLIENTACTIVETEXTUREARBPROC	glClientActiveTextureARB;
#endif

#ifndef POINT_SIZE_MIN_ARB
#define POINT_SIZE_MIN_ARB 0x8126
#endif

#ifndef COMPRESSED_RGBA_ARB
#define COMPRESSED_RGBA_ARB                             0x84EE
#endif

#ifndef COMPRESSED_RGBA_S3TC_DXT5_EXT
#define COMPRESSED_RGBA_S3TC_DXT5_EXT                  0x83F3
#endif

#define CHECK_GL_ERRORS()       //NOP

#endif
