#ifndef ENGLISH
#include "global.h"
#include "help_window.h"
#include "help_xml.h"
#include "../client_sources/particles.h"
#include "../client_sources/platform.h"

const int help_window_x = 20;
const int help_window_y = 20;
const int help_window_x_len = 505;
const int help_window_y_len = 520;
const int tab_x_size=120;
const int tab_y_size=20;
const int tab_x_start=0;
const int tab_y_start=4;

int help_window_win = 0;

int max_pages=0;
int cur_page=0;
int selected_tab = 0;
int n_tabs=0;

xmlDocPtr help_doc=NULL;

void display_help_window ()
{

   if (help_window_win <= 0)
   {

      help_window_win =
         create_window ("Aide", 0, 0, help_window_x, help_window_y,
                        help_window_x_len, help_window_y_len,
                        ELW_WIN_DEFAULT);
		
	  set_window_color(help_window_win, ELW_COLOR_BACK, 0.0f, 0.0f, 0.0f, 0.0f);	
      set_window_handler (help_window_win, ELW_HANDLER_DISPLAY,
                          &display_help_window_handler);

      set_window_handler (help_window_win, ELW_HANDLER_CLICK,
                          &check_help_window_interface);

   }
   else
   {

      show_window (help_window_win);

      select_window (help_window_win);

   }

   display_window (help_window_win);

}

int display_help_window_handler (window_info * win)
{
   int bar_size = ((win->len_y - 65) / (max_pages + 1));
   int bar_y1 = cur_page * bar_size + 40;
   int bar_y2 = bar_y1 + bar_size;

   glEnable (GL_BLEND);

   glBlendFunc (GL_ONE, GL_SRC_ALPHA);

   glDisable (GL_TEXTURE_2D);

   glDisable (GL_BLEND);

   glColor3f (0.77f, 0.57f, 0.39f);

   //toolbar
   glBegin (GL_LINES);
   glVertex3i (win->len_x - 20, 20, 0);
   glVertex3i (win->len_x - 20, win->len_y, 0);

   glVertex3i (win->len_x - 15, 30, 0);
   glVertex3i (win->len_x - 10, 25, 0);
   glVertex3i (win->len_x - 10, 25, 0);
   glVertex3i (win->len_x - 5, 30, 0);

   glVertex3i (win->len_x - 15, win->len_y - 15, 0);
   glVertex3i (win->len_x - 10, win->len_y - 10, 0);
   glVertex3i (win->len_x - 10, win->len_y - 10, 0);
   glVertex3i (win->len_x - 5, win->len_y - 15, 0);
   glEnd ();
   
   //the bar
   glBegin (GL_QUADS);
   glVertex3i (win->len_x - 15, bar_y1, 0);
   glVertex3i (win->len_x - 5, bar_y1, 0);
   glVertex3i (win->len_x - 5, bar_y2, 0);
   glVertex3i (win->len_x - 15, bar_y2, 0);
   glEnd ();
   
   glEnable (GL_TEXTURE_2D);

   // The X
   draw_string (0 + win->len_x - 16, 0 + 2, (const unsigned char *) "X", 1);
  
   //On affiche le contenu de la page
   	draw_xml_help(help_doc, selected_tab, cur_page);
   return 1;
}

int check_help_window_interface (window_info * win, int _x, int _y)
{
   //top button (toolbar)
   int h1_x1 = help_window_x_len - 20;
   int h1_x2 = help_window_x_len;
   int h1_y1 = 20;
   int h1_y2 = 40;

   //bottom button (toolbar)
   int h2_x1 = help_window_x_len - 20;
   int h2_x2 = help_window_x_len;
   int h2_y1 = help_window_y_len - 20;
   int h2_y2 = help_window_y_len;


   if (_x > h1_x1 && _x <= h1_x2 && _y > h1_y1 && _y <= h1_y2)
   {
      if (cur_page > 0)
         cur_page--;
   }

   if (_x > h2_x1 && _x <= h2_x2 && _y > h2_y1 && _y <= h2_y2)
   {
      if (cur_page < max_pages)
         cur_page++;
   }
    
   //onglets 		
   if(_x > tab_x_start && _y > tab_y_start && _y <= (tab_y_start+tab_y_size) && _x <= (n_tabs*tab_x_size+tab_x_start))
   {
   		cur_page = 0;
   		selected_tab = (_x)/tab_x_size;
   }
   return 1;

}
void draw_tab(const char *tab, int tab_id)
{
    glDisable (GL_TEXTURE_2D);

	glColor3f (0.77f, 0.57f, 0.39f);
	glBegin(GL_LINES);
	glVertex3i ((tab_id)*tab_x_size, tab_y_start, 0);
	glVertex3i((tab_id)*tab_x_size, tab_y_start+tab_y_size, 0);
	glVertex3i ((tab_id)*tab_x_size, tab_y_start, 0);
	glVertex3i ((tab_id+1)*tab_x_size, tab_y_start, 0);
	glVertex3i ((tab_id+1)*tab_x_size, tab_y_start, 0);
	glVertex3i ((tab_id+1)*tab_x_size, tab_y_start+tab_y_size, 0);
	if(tab_id != selected_tab)
	{
		glVertex3i ((tab_id)*tab_x_size, tab_y_start+tab_y_size, 0);
		glVertex3i ((tab_id+1)*tab_x_size, tab_y_start+tab_y_size, 0);
	}	
	glEnd();
	glEnable (GL_TEXTURE_2D);
	draw_string_small((tab_id)*tab_x_size+5, tab_y_start+2, (unsigned char*)tab, 1);
}
#endif //ENGLISH


