#ifndef ENGLISH
#include "help_xml.h"
#include "../client_sources/asc.h"
extern int max_pages;
//couleurs RGB
float r=1.0f;
float b=1.0f;
float g=1.0f;
//position du texte  afficher
int x=5;
int y=25;
//taille du texte :
double zoom = 0.7f;
//page et onglet lue actuellement
int tab_read = 0;
char tab_name[20] = {0};
int page_read = 0;

int calc_line_len(void)
{
	return zoom*18;
}

//couleur suivant le nom
void GetColorFromName (const xmlChar *t)
{
	if(!xmlStrcasecmp((xmlChar*)"silver",t)){r=192/255.0f; g=192/255.0f; b=192/255.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"grey",t)){r=128/255.0f; g=128/255.0f; b=128/255.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"maroon",t)){r=128/255.0f; g=0.0f; b=0.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"green",t)){r=0.0f; g=128/255.0f; b=0.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"navy",t)){r=0.0f; g=0.0f; b=128/255.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"olive",t)){r=128/255.0f; g=128/255.0f; b=0.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"purple",t)){r=128/255.0f; g=0.0f; b=128/255.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"teal",t)){r=0.0f; g=128/255.0f; b=128/255.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"white",t)){r=1.0f; g=1.0f; b=1.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"black",t)){r=0.0f; g=0.0f; b=0.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"red",t)){r=1.0f; g=0.0f; b=0.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"lime",t)){r=0.0f; g=1.0f; b=0.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"blue",t)){r=0.0f; g=0.0f; b=1.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"magenta",t)){r=1.0f; g=0.0f; b=1.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"yellow",t)){r=1.0f; g=1.0f; b=0.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"cyan",t)){r=0.0f; g=1.0f; b=1.0f;return;}
	if(!xmlStrcasecmp((xmlChar*)"gold",t)){r=1.0f; g=0.8f; b=0.6f;return;}
}

//On rcupre les attributs de <Text>
void ParseText(xmlAttr *a_node)
{
	xmlAttr *cur_attr=NULL;

	for (cur_attr = a_node; cur_attr; cur_attr = cur_attr->next) {
		if (cur_attr->type==XML_ATTRIBUTE_NODE){
			//color=""
			if(!xmlStrcasecmp(cur_attr->name,(xmlChar*)"color")){
				GetColorFromName (cur_attr->children->content);
			}
			//x=""
			if(!xmlStrcasecmp(cur_attr->name, (xmlChar*)"x")){
				x = strtol((char*)cur_attr->children->content, NULL, 0);
			}
			//y=""
			if(!xmlStrcasecmp(cur_attr->name, (xmlChar*)"y")){
				y = strtol((char*)cur_attr->children->content, NULL, 0);
			}	
			//size=""
			if(!xmlStrcasecmp(cur_attr->name, (xmlChar*)"size")){
				zoom = strtol((char*)cur_attr->children->content, NULL, 0);
				zoom /= 100;
			}					
		}
	}
}
//On rcupre les attributs de <Page>
void ParsePage(xmlAttr *a_node)
{
	xmlAttr *cur_attr=NULL;

	for (cur_attr = a_node; cur_attr; cur_attr = cur_attr->next) {
		if (cur_attr->type==XML_ATTRIBUTE_NODE){
			//id=""
			if(!xmlStrcasecmp(cur_attr->name,(xmlChar*)"id")){
				page_read = strtol((char*)cur_attr->children->content, NULL, 0);
			}
		}
	}
}
//On rcupre les attributs de <Tab>
void ParseTab(xmlAttr *a_node, int tab_id)
{
	xmlAttr *cur_attr=NULL;
	for (cur_attr = a_node; cur_attr; cur_attr = cur_attr->next) {
		if (cur_attr->type==XML_ATTRIBUTE_NODE){
			//name=""
			if(!xmlStrcasecmp(cur_attr->name,(xmlChar*)"name")){
					strncpy(tab_name, (char*)cur_attr->children->content, sizeof(tab_name)-1);
			}
			//pages=""
			if(!xmlStrcasecmp(cur_attr->name,(xmlChar*)"pages")){
				if(tab_id == tab_read)
					max_pages=strtol((char*)cur_attr->children->content, NULL, 0);
			}
			//id=""
			if(!xmlStrcasecmp(cur_attr->name,(xmlChar*)"id")){
				tab_read = strtol((char*)cur_attr->children->content, NULL, 0);
				if(tab_read+1 > n_tabs)
					n_tabs = tab_read+1;
			}			
		}
	}
}
//On parse le document, et on l'affiche
void ReadCategoryXML(xmlNode * a_node, int tab_id, int page_id)
{
	xmlNode *cur_node=NULL;
	
	for (cur_node = a_node; cur_node; cur_node = cur_node->next) {
		if (cur_node->type==XML_ELEMENT_NODE){
			//<Page>
			if(!xmlStrcasecmp(cur_node->name,(xmlChar*)"Page")){
				ParsePage(cur_node->properties);
				x=5;
    			y=25;
			}
			//<nl>
			if(!xmlStrcasecmp(cur_node->name, (xmlChar*)"nl")){
				y += calc_line_len();
				x=5;
			}
			//<Tab>
			if(!xmlStrcasecmp(cur_node->name, (xmlChar*)"Tab")){
				ParseTab(cur_node->properties, tab_id);
				draw_tab(tab_name, tab_read);
			}
			//<Text>
			if(!xmlStrcasecmp(cur_node->name, (xmlChar*)"Text")){
				//Le texte appartient-il  la page qui doit tre affiche?
				if(page_id == page_read && tab_read==tab_id)
				{
					char *c = NULL, *pt = NULL;
					char *ptr = strdup((char*)cur_node->children->content);
					pt = ptr;
					ParseText(cur_node->properties);
					glColor3f(r, g, b);		
					do
					{
						if(c)
						*c = 0;	
						draw_string_zoomed (x, y, (const unsigned char*)fromUTF8((unsigned char*)pt, strlen(pt)), 1, zoom);	
						if(c)
						x += strlen(pt)*10.f*zoom;
						if(c)
						pt = c+1;								
					}while((c = strchr(pt, '\n')) != NULL);	
					r=1.0f;
					g=1.0f;
					b=1.0f;
					free(ptr);
				}	
			}
		}
		ReadCategoryXML(cur_node->children, tab_id, page_id);		
	}
}
//Affiche dans l'aide la page "page_id" dans l'onglet "tab"
void draw_xml_help(xmlDoc *doc, int tab_id, int page_id)
{
	if(doc == NULL) return;
	//On initialise les variables globales
    zoom=0.7f;
	ReadCategoryXML(doc->children, tab_id, page_id);
}
//Charge un document XML en mmoire et le retourne
xmlDocPtr LoadXML(const char *filename)
{
	char path[128] = {0};
	xmlDocPtr doc = NULL;
	snprintf(path, 127, "%s%s", datadir, filename);
	if((doc=xmlReadFile(path, NULL, 0)) == NULL)
	{
		LOG_ERROR("can't open %s", path);
		return NULL;
	}	

	return doc;
}
// Libre l'espace alloue par le document
void FreeXML(xmlDoc *doc)
{
	xmlFreeDoc(doc);
	doc = NULL;
}
#endif //ENGLISH
