#include "global.h"
#include "mult_obj.h"
int mult_objects[MAX_MULT_OBJ];

void reset_mult_obj ()
{
   int i;
   for (i = 0; i < MAX_MULT_OBJ; i++)
   {
      mult_objects[i] = -1;
   }
   selected_3d_object =-1;
}

void transform_all_obj (SDL_Event * event)
{
   int i;
   SDLKey key = event->key.keysym.sym;
   if (cur_tool != tool_mult)
      return;     
   for (i = 0; i < MAX_MULT_OBJ; i++)
   {
      if (mult_objects[i] != -1 && objects_list[mult_objects[i]] != NULL)
      {      
         switch (key)
         {
         
         //X, Y Z Pos
         case SDLK_x:
            if(!alt_on)
                objects_list[mult_objects[i]]->x_pos += shift_on ? 0.01f : 0.1f;
            if(alt_on)
            	objects_list[mult_objects[i]]->x_pos -= shift_on ? 0.01f : 0.1f;
            break;
         case SDLK_y:
            if(!alt_on)
                objects_list[mult_objects[i]]->y_pos += shift_on ? 0.01f : 0.1f;
            if(alt_on)
            	objects_list[mult_objects[i]]->y_pos -= shift_on ? 0.01f : 0.1f;
            break;
         case SDLK_z:
            if(!alt_on)
                objects_list[mult_objects[i]]->z_pos += shift_on ? 0.01f : 0.1f;
            if(alt_on)
            	objects_list[mult_objects[i]]->z_pos -= shift_on ? 0.01f : 0.1f;  
            	break; 
         case SDLK_DELETE: 
              objects_list[mult_objects[i]]->z_pos -= shift_on ? 0.01f : 0.1f;      
              break;       
         case SDLK_INSERT:                           
         case SDLK_BACKSPACE:  
         	objects_list[mult_objects[i]]->z_pos += shift_on ? 0.01f : 0.1f;
              break; 	
            	
         //Colors RGB   	
         case SDLK_KP1:
             if(objects_list[mult_objects[i]]->color[0] < 1.0f && !alt_on)
             	objects_list[mult_objects[i]]->color[0] += 0.05f;
             if(objects_list[mult_objects[i]]->color[0] > 0.0f && alt_on)	
                objects_list[mult_objects[i]]->color[0] -= 0.05f;
             break;
         case SDLK_KP2:
             if(objects_list[mult_objects[i]]->color[1] < 1.0f && !alt_on)
             	objects_list[mult_objects[i]]->color[1] += 0.05f;
             if(objects_list[mult_objects[i]]->color[1] > 0.0f && alt_on)	
                objects_list[mult_objects[i]]->color[1] -= 0.05f;
             break;
         case SDLK_KP3:
             if(objects_list[mult_objects[i]]->color[2] < 1.0f && !alt_on)
             	objects_list[mult_objects[i]]->color[2] += 0.05f;
             if(objects_list[mult_objects[i]]->color[2] > 0.0f && alt_on)	
                objects_list[mult_objects[i]]->color[2] -= 0.05f;
            break; 
            
         //X, Y, Z Rot 
         case SDLK_LEFT:
           if(ctrl_on || shift_on)
         	objects_list[mult_objects[i]]->z_rot -= (shift_on ? 1.0f : 10.0f);
         	break;
         case SDLK_RIGHT:
           if(ctrl_on || shift_on)
         	objects_list[mult_objects[i]]->z_rot += (shift_on ? 1.0f : 10.0f);
         	break;
         case SDLK_DOWN:
           if(ctrl_on || shift_on)
         	objects_list[mult_objects[i]]->x_rot += (shift_on ? 1.0f : 10.0f);
         	break;
         case SDLK_UP:
           if(ctrl_on || shift_on)
         	objects_list[mult_objects[i]]->x_rot -= (shift_on ? 1.0f : 10.0f);
         	break;
         case SDLK_PAGEUP:
           if(ctrl_on || shift_on)
         	objects_list[mult_objects[i]]->y_rot -= (shift_on ? 1.0f : 10.0f);
         	break;
         case SDLK_PAGEDOWN:  
           if(ctrl_on || shift_on)
            objects_list[mult_objects[i]]->y_rot += (shift_on ? 1.0f : 10.0f);	
             break;
             
         //self lit
         case SDLK_l:
            objects_list[mult_objects[i]]->self_lit =!objects_list[mult_objects[i]]->self_lit;
            break;
            
         //Blended
         case SDLK_b:
         	objects_list[mult_objects[i]]->blended =!objects_list[mult_objects[i]]->blended;
           break;
         
         //Dtruis tous les objets
         case SDLK_s:
             kill_3d_object(mult_objects[i]);
             mult_objects[i] = -1;
             break;
               
         //Invalid KEYDOWN           
         default:
            return;
            break;
         }
      }
      else if(mult_objects[i] != -1 && objects_list[i] == NULL) //the object is probably removed : update mult_objects
      {
           mult_objects[i] = -1;
      }
   }
}

void add_mult_obj ()
{
   int i;
   if (selected_3d_object == -1)
      return;
   //On recherche le premier lment vide du tableau pour le remplir   
   for (i = 0; i < MAX_MULT_OBJ; i++)
   {
      if (mult_objects[i] == -1)
      {
         mult_objects[i] = selected_3d_object;
         break;
      }
   }
   LOG_ERROR ("Too many mult_objects!\n");
}
int remove_mult_obj ()
{
   int i;
   int ret = 0;
   //On recherche l'objet selectionn dans le tableau
   for(i = 0; i < MAX_MULT_OBJ; i++)
   {
      if(selected_3d_object == mult_objects[i])
      {
          mult_objects[i] = -1;//on le supprime du tableau et on le dselectionne
          selected_3d_object = -1;
          ret = 1;
          break;
      }
   }
   //On selectionne le premier objet dans le tableau si un lment a t supprim
   if(ret)
   {  
     for(i = 0; i < MAX_MULT_OBJ; i++)
     { 
     	if(mult_objects[i] != -1 && objects_list[mult_objects[i]] != NULL)
     	{
        	  selected_3d_object = mult_objects[i];   
        	  break;
        }	  
     }  	  
   }         
   return ret;
}
void print_tab()
{  
    //Fonction de dbugage
    int i;
    printf("MULT OBJ :\n=======================\n");
    for(i = 0; i < MAX_MULT_OBJ; i++)
    {
        if(mult_objects[i] != -1)
          printf("i = %d | ID : %d\n",i, mult_objects[i]);
    } 
    printf("=======================\n");
}
void previous_mult_obj()
{
   int i;
   if(selected_3d_object == -1 && cur_tool != tool_mult) return;
   //recherche de l'objet selectionn
     for(i = 0; i < MAX_MULT_OBJ; i++) 
     {
        if(selected_3d_object == mult_objects[i])
           break;
     }
     if(i > 0) i--; //On prends l'objet prcedent et on le selectionne.
     if(mult_objects[i] != -1 && objects_list[mult_objects[i]] != NULL)
       selected_3d_object = mult_objects[i];
}
void next_mult_obj()
{
     int i;
     if(selected_3d_object == -1 && cur_tool != tool_mult) return;
     //on cherche l'objet selectionn
     for(i = 0; i < MAX_MULT_OBJ; i++)
     {
        if(selected_3d_object == mult_objects[i])
           break;       
     }
     if(i < MAX_MULT_OBJ-1) i++; //On prends l'objet suivant et on le selectionne.
     if(mult_objects[i] != -1 && objects_list[mult_objects[i]] != NULL)
        selected_3d_object = mult_objects[i];
}

